/* cetnostslov1a.c */
/* Precte textovy soubor a vypise tabulku cetnosti slov.
   Slovo je posloupnost max. 20ti velkych a malych pismen
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXDELKASLOVA 20
#define MAXPOCET 100

typedef char SLOVO[MAXDELKASLOVA+1];

int jePismeno(char z) {
  return z>='a' && z<='z' || z>='A' && z<='Z';
}

int ctiSlovo(FILE *vstup, SLOVO slovo) {
   int znak;
   int i = 0;
   do {
      znak = getc(vstup);
   } while (znak!=EOF && !jePismeno(znak));
   if (znak==EOF) return EOF;
   do {
     slovo[i++] = znak;
     znak = getc(vstup);
   } while (jePismeno(znak));
   slovo[i] = 0;
   return 0;
}
   
typedef struct zaznam {
  SLOVO slovo;
  int cetnost;
} ZAZNAM;

ZAZNAM tabulka[MAXPOCET+1];
int volny;

void doplnSlovo(SLOVO slovo) {
   int i = 0;
   strcpy(tabulka[volny].slovo, slovo);
   /* hledani se zarazkou */ 
   while (strcmp(tabulka[i].slovo, slovo)!=0) i++;
   if (i<volny)
      tabulka[i].cetnost++;
   else {
      tabulka[volny].cetnost = 1;
      volny++;
   }
}

void vypisTabulku() {
  int i;
  for (i=0; i<volny; i++) 
    printf("%20s %d\n", tabulka[i].slovo, tabulka[i].cetnost);
}

FILE *otevriSoubor(char *jmeno, char* mode) {
  FILE *soubor;
  soubor = fopen(jmeno, mode);
  if (!soubor) {
    printf("spatne jmeno souboru\n");
    system("PAUSE");
    exit(1);
  }
  return soubor;
}
     
int main(void) {
  FILE *vstup = otevriSoubor("cetnostslov1a.c", "r");
  SLOVO slovo;
  volny = 0;
  while (ctiSlovo(vstup, slovo)!=EOF)
    doplnSlovo(slovo);
  vypisTabulku();
  system("PAUSE");
  return 0;
}
