/* cetnostslov1b.c */
/* Precte textovy soubor a vypise tabulku cetnosti slov.
   Slovo je posloupnost max. 20ti velkych a malych pismen.
   Prace s tabulkou pomoci ukazatelu.
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXDELKASLOVA 20
#define MAXPOCET 100

typedef char SLOVO[MAXDELKASLOVA+1];

int jePismeno(char z) {
  return z>='a' && z<='z' || z>='A' && z<='Z';
}

int ctiSlovo(FILE *vstup, SLOVO slovo) {
   int znak;
   int i = 0;
   do {
      znak = getc(vstup);
   } while (znak!=EOF && !jePismeno(znak));
   if (znak==EOF) return EOF;
   do {
     slovo[i++] = znak;
     znak = getc(vstup);
   } while (jePismeno(znak));
   slovo[i] = 0;
   return 0;
}
   
typedef struct zaznam {
  SLOVO slovo;
  int cetnost;
} ZAZNAM;

ZAZNAM tabulka[MAXPOCET+1];
ZAZNAM *ptrVolny;

void doplnSlovo(SLOVO slovo) {
   printf("%s\n", slovo);
   ZAZNAM *p = tabulka;
   strcpy(ptrVolny->slovo, slovo);
   /* hledani se zarazkou */ 
   while (strcmp(p->slovo, slovo)!=0) p++;
   if (p<ptrVolny)
      p->cetnost++;
   else {
      ptrVolny->cetnost = 1;
      ptrVolny++;
   }
}

void vypisTabulku() {
  ZAZNAM *p;
  for (p=tabulka; p<ptrVolny; p++) 
    printf("%20s %d\n", p->slovo, p->cetnost);
}

FILE *otevriSoubor(char *jmeno, char* mode) {
  FILE *soubor;
  soubor = fopen(jmeno, mode);
  if (!soubor) {
    printf("spatne jmeno souboru\n");
    system("PAUSE");
    exit(1);
  }
  return soubor;
}     
int main(void) {
  FILE *vstup = otevriSoubor("cetnostslov1a.c", "r");
  SLOVO slovo;
  ptrVolny = tabulka;
  while (ctiSlovo(vstup, slovo)!=EOF)
    doplnSlovo(slovo);
  vypisTabulku();
  system("PAUSE");
  return 0;
}
