/* prog11-studenti4a.c */
/* precte textovy soubor obsahujici jmeno, prijmeni a studijni prumer studentu,
   zaznamy ulozi do pole, pole seradi podle prumeru a pak vypise.
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXDELKA 20
#define MAXPOCET 20

typedef struct student {
  char jmeno[MAXDELKA];
  char prijmeni[MAXDELKA];
  float prumer;
} Student;

FILE *otevriSoubor(char *jmeno, char* mode) {
  FILE *soubor;
  soubor = fopen(jmeno, mode);
  if (!soubor) {
    printf("spatne jmeno souboru\n");
    system("PAUSE");
    exit(1);
  }
  return soubor;
}

void vypisStudenta(Student student) {
  printf("%s %s %.1f\n", student.jmeno, student.prijmeni, student.prumer);
}

void vymena(Student *p, Student *q) {
  Student pom;
  pom = *p;
  *p = *q;
  *q = pom;
}
void seradPodlePrumeru(Student a[], int n) {
    int i, j, imin;
    for (i=0; i<n-1; i++) {
      imin = i;
      for (j=i+1; j<n; j++)
          if (a[j].prumer<a[imin].prumer) imin = j;
      if (imin!=i) 
        vymena(&a[imin], &a[i]);
    }
}  

int main(void) {
  Student studenti[MAXPOCET];
  int pocet = 0, i;
  FILE *vstup = otevriSoubor("studenti.txt", "r");
  while (pocet<MAXPOCET &&
         fscanf(vstup, "%s%s%f", studenti[pocet].jmeno, studenti[pocet].prijmeni, &studenti[pocet].prumer)!=EOF)
    pocet++;
  fclose(vstup);
  seradPodlePrumeru(studenti, pocet);
  for (i=0; i<pocet; i++)
    vypisStudenta(studenti[i]); 
  system("PAUSE");
  return 0;
}

      
