/* prog11-studenti6.c */
/* Do serazeneho binarniho souboru doplni na spravne misto noveho studenta.
   Jmeno souboru a udaje o novem studentovi precte z klavesnice.
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXDELKA 20
#define MAXPOCET 20

typedef struct student {
  char jmeno[MAXDELKA];
  char prijmeni[MAXDELKA];
  float prumer;
} Student;

FILE *otevriSoubor(char *jmeno, char* mode) {
  FILE *soubor;
  soubor = fopen(jmeno, mode);
  if (!soubor) {
    printf("spatne jmeno souboru %s\n", jmeno);
    system("PAUSE");
    exit(1);
  }
  return soubor;
}

int ctiStudenta(FILE *vstup, Student *ps) {
  int vysl;
  Student s;
  vysl = fscanf(vstup, "%s%s%f", s.jmeno, s.prijmeni, &s.prumer);
  *ps = s;
  return vysl;
}

void vypisStudenta(Student student) {
  printf("%20s %20s %.1f\n", student.jmeno, student.prijmeni, student.prumer);
}

int main(void) {
  Student dalsi, novy;
  char jmenoSouboru[MAXDELKA];
  printf("zadej jmeno souboru: ");
  scanf("%s", jmenoSouboru);
  FILE *soubor = otevriSoubor(jmenoSouboru, "rb");
  FILE *pomocny = otevriSoubor("pomocny", "wb");
  
  /* cteni noveho studenta */
  printf("zadej jmeno prijmeni a prumer noveho studenta\n");
  ctiStudenta(stdin, &novy);

  /* zkopiruji se studenti, kteri nemaji horsi prumer nez novy */  
  int p;
  while ((p=fread(&dalsi, sizeof(Student), 1, soubor))==1 &&
         dalsi.prumer<=novy.prumer)
     fwrite(&dalsi, sizeof(Student), 1, pomocny);
     
  /* zapise se novy student */  
  fwrite(&novy, sizeof(Student), 1, pomocny);
  
  /* zkopiruje se zbytek studentu, ale jen tehdy, kdyz 
   v predchozim cyklu byl dalsi student precten */
  if (p) {
     fwrite(&dalsi, sizeof(Student), 1, pomocny);
     while (fread(&dalsi, sizeof(Student), 1, soubor)==1)
        fwrite(&dalsi, sizeof(Student), 1, pomocny);
  }
  
  /* soubory se uzavrou */
  fclose(pomocny);
  fclose(soubor);
  
  /* a otevrou pro prepsani souboru pomocnym */
  soubor = otevriSoubor(jmenoSouboru, "wb");
  pomocny = otevriSoubor("pomocny", "rb");
  
  /* prepsani souboru pomocnym */
  while (fread(&dalsi, sizeof(Student), 1, pomocny)==1)
     fwrite(&dalsi, sizeof(Student), 1, soubor);
  fclose(pomocny);
  fclose(soubor);
  
  /* a na zaver vypis doplneneho souboru */
  printf("vypis doplneneho souboru\n");
  soubor = otevriSoubor(jmenoSouboru, "rb");
  while (fread(&dalsi, sizeof(Student), 1, soubor)==1)
    vypisStudenta(dalsi);
  fclose(soubor);

  system("PAUSE");
  return 0;
}

      
