/* prog12-morseovka.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct MUzel {
  char znak;
  struct MUzel *tecka, *carka;
} MUzel;

MUzel *novyMUzel(char z, MUzel *t, MUzel *c) {
  MUzel *p = (MUzel*)malloc(sizeof(MUzel));
  p->znak = z;
  p->tecka = t;
  p->carka = c;
  return p;
}

MUzel *novyMUzel1(char z) {
  MUzel *p = (MUzel*)malloc(sizeof(MUzel));
  p->znak = z;
  p->tecka = NULL;
  p->carka = NULL;
  return p;
}
 
MUzel *strom() {
    return
      novyMUzel(' ',
        novyMUzel('E',          /* .     */
          novyMUzel('I',        /* ..    */
            novyMUzel('S',      /* ...   */
              novyMUzel1('H'),  /* ....  */
              novyMUzel1('V')   /* ...-  */
            ),
            novyMUzel('U',      /* ..-   */
              novyMUzel1('F'),  /* ..-.  */
              NULL              /* ..--  */
            )
          ),
          novyMUzel('A',        /* .-    */ 
            novyMUzel('R',      /* .-.   */
              novyMUzel1('L'),  /* .-..  */
              NULL              /* .-.-  */
            ),
            novyMUzel('W',      /* .--   */
              novyMUzel1('P'),  /* .--.  */
              novyMUzel1('J')   /* .---  */
            )
          )
        ),
        novyMUzel('T',          /* -     */
          novyMUzel('N',        /* -.    */
            novyMUzel('D',      /* -..   */
              novyMUzel1('B'),  /* -...  */
              novyMUzel1('X')   /* -..-  */
            ),
            novyMUzel('K',      /* -.-   */
              novyMUzel1('C'),  /* -.-.  */
              novyMUzel1('Y')   /* -.--  */
            )
          ),
          novyMUzel('M',        /* --    */
            novyMUzel('G',      /* --.   */
              novyMUzel1('Z'),  /* --..  */
              novyMUzel1('Q')   /* --.-  */
            ),
            novyMUzel1('O')     /* ---   */
          )
        )
      );
}

MUzel *koren;

void dekoduj(char odkud[], char kam[]) {
    MUzel *aktualni = koren;
    int i = 0, j = 0, delka = strlen(odkud);
    while (i<delka) {
      char z = odkud[i];
      if (aktualni!=NULL) {
        if (z=='.') aktualni = aktualni->tecka;
        else if (z=='-') aktualni = aktualni->carka;
        else {
          kam[j++] = aktualni->znak;
          aktualni = koren;
        }
        i++;
      }
      else {
        kam[j++] = '?';
        while (odkud[i]=='.' || odkud[i]=='-') i++;
        aktualni = koren;
      }
    }
    kam[j] = 0;
}

#define MAXDELKA 100

int main() {
  koren = strom();
  char morse[MAXDELKA], text[MAXDELKA];
  fgets(morse, MAXDELKA, stdin);
  dekoduj(morse, text);
  fprintf(stdout, "%s\n", text);
  system("PAUSE");
  return 0;
}
